## ghostscript 9.18~dfsg~0

=== openjpeg/src/lib/openjp2/CMakeLists.txt ===
include_regular_expression("^.*$")

#
install( FILES  ${CMAKE_CURRENT_BINARY_DIR}/opj_config.h
 DESTINATION ${OPENJPEG_INSTALL_INCLUDE_DIR} COMPONENT Headers)

include_directories(
  ${OPENJPEG_BINARY_DIR}/src/lib/openjp2 # opj_config.h and opj_config_private.h
)
# Defines the source code for the library
set(OPENJPEG_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/bio.c
  ${CMAKE_CURRENT_SOURCE_DIR}/cio.c
  ${CMAKE_CURRENT_SOURCE_DIR}/dwt.c
  ${CMAKE_CURRENT_SOURCE_DIR}/event.c
  ${CMAKE_CURRENT_SOURCE_DIR}/image.c
  ${CMAKE_CURRENT_SOURCE_DIR}/invert.c
  ${CMAKE_CURRENT_SOURCE_DIR}/j2k.c
  ${CMAKE_CURRENT_SOURCE_DIR}/jp2.c
  ${CMAKE_CURRENT_SOURCE_DIR}/mct.c
  ${CMAKE_CURRENT_SOURCE_DIR}/mqc.c
  ${CMAKE_CURRENT_SOURCE_DIR}/openjpeg.c
  ${CMAKE_CURRENT_SOURCE_DIR}/opj_clock.c
  ${CMAKE_CURRENT_SOURCE_DIR}/pi.c
  ${CMAKE_CURRENT_SOURCE_DIR}/raw.c
  ${CMAKE_CURRENT_SOURCE_DIR}/t1.c
  ${CMAKE_CURRENT_SOURCE_DIR}/t2.c
  ${CMAKE_CURRENT_SOURCE_DIR}/tcd.c
  ${CMAKE_CURRENT_SOURCE_DIR}/tgt.c
  ${CMAKE_CURRENT_SOURCE_DIR}/function_list.c
)
if(BUILD_JPIP)
  add_definitions(-DUSE_JPIP)
  set(OPENJPEG_SRCS
    ${OPENJPEG_SRCS}
    ${CMAKE_CURRENT_SOURCE_DIR}/cidx_manager.c
    ${CMAKE_CURRENT_SOURCE_DIR}/phix_manager.c
    ${CMAKE_CURRENT_SOURCE_DIR}/ppix_manager.c
    ${CMAKE_CURRENT_SOURCE_DIR}/thix_manager.c
    ${CMAKE_CURRENT_SOURCE_DIR}/tpix_manager.c
  )
endif()

# Build the library
if(WIN32)
  if(BUILD_SHARED_LIBS)
    add_definitions(-DOPJ_EXPORTS)
  else()
    add_definitions(-DOPJ_STATIC)
  endif()
endif()
add_library(${OPENJPEG_LIBRARY_NAME} ${OPENJPEG_SRCS})
if(UNIX)
  target_link_libraries(${OPENJPEG_LIBRARY_NAME} m)
endif()
set_target_properties(${OPENJPEG_LIBRARY_NAME} PROPERTIES ${OPENJPEG_LIBRARY_PROPERTIES})

# Install library
install(TARGETS ${OPENJPEG_LIBRARY_NAME}
  EXPORT OpenJPEGTargets
  RUNTIME DESTINATION ${OPENJPEG_INSTALL_BIN_DIR} COMPONENT Applications
  LIBRARY DESTINATION ${OPENJPEG_INSTALL_LIB_DIR} COMPONENT Libraries
  ARCHIVE DESTINATION ${OPENJPEG_INSTALL_LIB_DIR} COMPONENT Libraries
)

# Install includes files
install(FILES openjpeg.h opj_stdint.h
  DESTINATION ${OPENJPEG_INSTALL_INCLUDE_DIR} COMPONENT Headers
)

if(BUILD_DOC)
# install man page of the library
install(
  FILES       ${OPENJPEG_SOURCE_DIR}/doc/man/man3/libopenjp2.3
  DESTINATION ${OPENJPEG_INSTALL_MAN_DIR}/man3)
endif()

# internal utilities to generate t1_luts.h (part of the jp2 lib)
# no need to install:
add_executable(t1_generate_luts t1_generate_luts.c)
if(UNIX)
  target_link_libraries(t1_generate_luts m)
endif()

# Experimental option; let's how cppcheck performs
# Implementation details:
# I could not figure out how to easily upload a file to CDash. Instead simply
# pretend cppcheck is part of the Build step. Technically cppcheck can even
# output gcc formatted error/warning report
# Another implementation detail: I could not redirect error to the error
# catching mechanism something is busted in cmake 2.8.5, I had to use the
# warning regex to catch them.
if(OPENJPEG_CPPCHECK)
  find_package(CPPCHECK REQUIRED)
  foreach(f ${OPENJPEG_SRCS})
    # cppcheck complains about too many configuration, pretend to be WIN32:
    add_custom_command(TARGET ${OPENJPEG_LIBRARY_NAME}
      COMMAND ${CPPCHECK_EXECUTABLE} -DWIN32 ${f})
  endforeach()
endif()

=== debian/changelog ===
ghostscript (9.18~dfsg~0-0ubuntu2) xenial; urgency=medium

  * Backport change from Debian 
    "Add patch cherry-picked upstream to fix add gserrors.h to the
     installed files for the so-install target."

 -- Sebastien Bacher <seb128@ubuntu.com>  Mon, 29 Feb 2016 11:35:03 +0100

ghostscript (9.18~dfsg~0-0ubuntu1) xenial; urgency=medium

  * New upstream release
     - Ghostscript 9.18
     - A new method of internally inserting devices into the device chain has
       been developed, named "device subclassing". This allows suitably
       written devices to be more easily and consistently as "filter" devices.
       The first fruit of this is a new implementation of the
       "-dFirstPage"/"-dLastPage" feature which functions a device filter in
       the Ghostscript graphics library, meaning it works consistently with
       all input languages.
     - Plus the usual round of bug fixes, compatibility changes, and incremental
       improvements.
  * 020150523_d73a342_gdevcups_support_color_spaces_18_19_20.patch,
    020150724_0c0b085_sanity_check_for_memory_allocation.patch: Removed,
    included upstream.
  * 2001_docdir_fix_for_debian.patch,
    1002_pxl-make-dicctransform-default.patch: Refreshed with quilt.
  * debian/symbols.common: Updated for new upstream source. Applied patch
    which dpkg-gensymbols generated for debian/libgs9.symbols to this file.

 -- Till Kamppeter <till.kamppeter@gmail.com>  Fri, 12 Feb 2016 19:29:28 -0200

ghostscript (9.16~dfsg~0-0ubuntu4) xenial; urgency=medium

  * Multiarchify the library packages.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 27 Jan 2016 23:10:38 +0100

=== debian/control ===
Source: ghostscript
Section: text
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
Build-Depends: cdbs (>= 0.4.72~),
 autoconf,
 debhelper,
 dh-buildinfo,
 devscripts,
 libfreetype6-dev,
 libcups2-dev (>= 1.3.7),
 libcupsimage2-dev (>= 1.1.20final+rc1-4),
 libdbus-1-dev,
 libjpeg-dev,
 libpaper-dev,
 libpng-dev,
 libz-dev,
 libfontconfig1-dev,
 libtiff-dev,
 libexpat-dev,
 libjbig2dec-dev,
 libidn11-dev,
 libijs-dev,
 freeglut3-dev | libglut-dev,
 libxt-dev,
 libxext-dev,
 libx11-dev,
 libice-dev,
 libsm-dev,
 liblcms2-dev, 
 pkg-config,
 d-shlibs (>= 0.45~)
Standards-Version: 3.9.3
Uploaders: Jonas Smedegaard <dr@jones.dk>,
 Michael Gilbert <michael.s.gilbert@gmail.com>
Homepage: http://www.ghostscript.com/
Vcs-Git: git://git.debian.org/git/collab-maint/ghostscript.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/ghostscript.git

Package: ghostscript
Architecture: any
Multi-Arch: foreign
Conflicts: ${cdbs:Conflicts}
Replaces: ${cdbs:Replaces}
Provides: ${cdbs:Provides}
Recommends: ${cdbs:Recommends}
Suggests: ${cdbs:Suggests}
Depends: ${shlibs:Depends},
 ${cdbs:Depends},
 libgs9 (= ${binary:Version}),
 ${misc:Depends}
Breaks: ${cdbs:Breaks}
Description: interpreter for the PostScript language and for PDF
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 Furthermore, it can render PostScript and PDF files as graphics to be
 printed on non-PostScript printers. Supported printers include common
 dot-matrix, inkjet and laser models.

Package: ghostscript-x
Architecture: any
Depends: ${shlibs:Depends},
 ${cdbs:Depends},
 ${misc:Depends}
Conflicts: ${cdbs:Conflicts}
Provides: ${cdbs:Provides}
Description: interpreter for the PostScript language and for PDF - X11 support
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package contains the GPL Ghostscript output device for X11.

Package: ghostscript-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends},
 ${cdbs:Depends},
 ${misc:Depends}
Suggests: ${cdbs:Suggests}
Conflicts: ${cdbs:Conflicts}
Description: interpreter for the PostScript language and for PDF - Documentation
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package contains documentation for GPL Ghostscript, mainly
 targeted developers and advanced users.

Package: libgs9
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
 ${cdbs:Depends},
 libgs9-common (>= ${source:Upstream-Version})
Description: interpreter for the PostScript language and for PDF - Library
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package provides the Ghostscript library which makes the
 facilities of GPL Ghostscript available to applications.

Package: libgs9-common
Section: libs
Architecture: all
Depends: ${misc:Depends}
Replaces: ${cdbs:Replaces}
Recommends: ${cdbs:Recommends}
Suggests: ${cdbs:Suggests}
Description: interpreter for the PostScript language and for PDF - common files
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package provides common architecture-independent files needed by
 the GPL Ghostscript library.
 .
 By default, GPL Ghostscript uses a font from the fonts-droid package to
 approximate glyphs in PDFs for which the requested CJK TrueType font
 is missing.  If the fonts-droid package is not installed, these glyphs
 will be rendered as bullets.

Package: libgs-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libgs9 (= ${binary:Version}),
 libc6-dev,
 libcups2-dev,
 libcupsimage2-dev,
 libfontconfig1-dev,
 libidn11-dev,
 libijs-dev,
 libjbig2dec0-dev,
 libjpeg-dev,
 libpaper-dev,
 libpng12-0-dev,
 libtiff5-dev,
 zlib1g-dev,
 ${cdbs:Depends},
 ${misc:Depends}
Conflicts: ${cdbs:Conflicts}
Replaces: ${cdbs:Replaces}
Provides: ${cdbs:Provides}
Description: interpreter for the PostScript language and for PDF - Development Files
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package provides the development files for the GPL Ghostscript
 library which makes the facilities of GPL Ghostscript available to
 applications.

Package: ghostscript-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${shlibs:Depends},
 ${cdbs:Depends},
 libgs9 (= ${binary:Version}) |
 ghostscript (= ${binary:Version}) |
 ghostcript-cups (= ${binary:Version}) |
 ghostcript-x (= ${binary:Version}),
 ${misc:Depends}
Description: interpreter for the PostScript language and for PDF - Debug symbols
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package contains the debugging symbols for ghostscript, ghostscript-x,
 ghostscript-cups and libgs9.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2004-2009, Masayuki Hatta (mhatta) <mhatta@debian.org>
# Copyright © 2009-2011, Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for GPL Ghostscript
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# This needs to run before cdbs auto-update
debian/control:: debian/control.in
DEB_PHONY_RULES += debian/control.in
debian/control.in::
	sed $(SEDRULE_CONTENT) <debian/control.in.in >debian/control.in

#DEB_BUILD_PARALLEL = yes
DEB_AUTO_UPDATE_AUTOCONF = 2.67
include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk

# ABI by default follows upstream version (without repackaging suffix)
abi = $(shell echo $(DEB_UPSTREAM_TARBALL_VERSION) | sed 's/[\~\+].*$$//')
major := $(shell echo $(DEB_UPSTREAM_VERSION) | sed 's/\..*$$//')
libname = libgs
libpkgname = $(libname)$(major)
datapkgname = $(libname)$(major)-common

DEB_UPSTREAM_URL = http://downloads.ghostscript.com/public
DEB_UPSTREAM_TARBALL_MD5 = 57ebf17c5abcf0fc95a386bfff08c1a4

# Sources unavailable
# (PDFs kept commented out as reminder, in case jasper is included)
#DEB_UPSTREAM_REPACKAGE_EXCLUDES += ./jasper/doc/*.pdf
# convenience libraries cluttering authorship/licensing tracking
#  * jpeg would enable old non-standard option (see bug#582521)
#  * jpegxr would enable patented controversial JPEG XR format
# We use Ghostscript's convenience libraries openjpeg and lcms2 for
# the time being as they contain API changes which did not make it
# upstream yet. So they do not get removed in the repackaging.
DEB_UPSTREAM_REPACKAGE_EXCLUDES += \
 ./cups/libs/ \
 ./expat/ \
 ./freetype/ \
 ./icclib \
 ./ijs/ \
 ./jasper/ \
 ./jbig2dec/ \
 ./jpeg/ \
 ./jpegxr/ \
 ./lcms/ \
 ./lcms2/ \
 ./libpng/ \
 ./tiff/ \
 ./zlib/

DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^(examples/.*\.pdf|iccprofiles/.*\.icc|toolbin/.*/.*\.icc|Resource/Font/.*|debian/(changelog|copyright(|_hints|_newhints)))$

# put aside upstream-shipped temp files during build but after copyright-check
upstreamtmpfiles = configure
pre-build:: debian/stamp-upstreamtmpstuff

debian/stamp-upstreamtmpstuff: debian/stamp-copyright-check
	for file in $(upstreamtmpfiles); do \
		[ ! -e $$file ] || [ -e $$file.upstream ] || cp -a $$file $$file.upstream; \
	done
	touch $@
clean::
	for file in $(upstreamtmpfiles); do \
		[ ! -e $$file.upstream ] || mv -f $$file.upstream $$file; \
	done
	rm -f debian/stamp-upstreamtmpstuff

# workaround for autotools-resolved paths ignored in base/unix-auth.mak
export DEB_HOST_MULTIARCH

# Use system libraries
# (listed in order of appearance)
# We have to add zlib_h= here due to a bug in the build system of GS 9.16
gs_opts = \
 SHARE_JPEG=1 \
 SHARE_LIBPNG=1 \
 SHARE_LIBTIFF=1 \
 SHARE_ZLIB=1 zlib_h= \
 SHARE_JBIG2=1 \
 SHARE_IJS=1 \
 SHARE_EXPAT=1

DEB_CONFIGURE_EXTRA_FLAGS = \
 --with-ijs --with-jbig2dec --with-system-libtiff \
 --with-x --disable-gtk \
 --enable-dynamic --disable-compile-inits \
 --with-drivers=ALL \
 --with-fontpath=/var/lib/ghostscript/fonts:/usr/share/cups/fonts:/usr/share/ghostscript/fonts:/usr/local/lib/ghostscript/fonts:/usr/share/fonts

# We use Ghostscript's own LCMS2 as the upstream one does not yet contain
# the API changes needed for GS 9.07
#gs_opts += WHICH_CMS=lcms2 SHARE_LCMS=0 LCMS2DIR=/usr
gs_opts += WHICH_CMS=lcms2 SHARE_LCMS=1 LCMS2DIR=/usr
CDBS_BUILD_DEPENDS += , liblcms2-dev

# openjpeg requires patching for ICC and CMYK support
gs_opts += SHARE_JPX=0
#gs_opts += SHARE_JPX=1
DEB_CONFIGURE_EXTRA_FLAGS += --enable-openjpeg --without-jasper
#CDBS_BUILD_DEPENDS += , libopenjeg-dev

gs_opts += SHARE_FT=1
DEB_CONFIGURE_EXTRA_FLAGS += --enable-freetype
CDBS_BUILD_DEPENDS += , libfreetype6-dev

gs_opts += SHARE_LCUPS=1 SHARE_LCUPSI=1
gs_opts += CUPSDATA=/usr/share/ppd/ghostscript
DEB_CONFIGURE_EXTRA_FLAGS += --enable-cups --enable-dbus
CDBS_BUILD_DEPENDS += , libcups2-dev (>= 1.3.7), libcupsimage2-dev (>= 1.1.20final+rc1-4)
CDBS_BUILD_DEPENDS += , libdbus-1-dev

DEB_MAKE_BUILD_TARGET = so gs.a $(gs_opts)
DEB_MAKE_INSTALL_TARGET = soinstall DESTDIR=$(DEB_DESTDIR) $(gs_opts)

DEB_DH_MAKESHLIBS_ARGS_ghostscript-x = -n

SEDRULE_CONTENT = 's/__ABI__/$(abi)/g;s/__VER__/$(major)/g'

pre-build:: debian/control.in.in
	echo "sed $(SEDRULE_CONTENT) <$< | diff -u debian/control.in -"
	@sed $(SEDRULE_CONTENT) <$< | diff -u debian/control.in - || ( \
		echo; \
		echo "Upstream version has changed (or debian/control.in.in is out of sync)"; \
		echo "Edit debian/control manually, or use the following command:"; \
		echo "  DEB_AUTO_UPDATE_DEBIAN_CONTROL=yes fakeroot debian/rules clean"; \
		exit 1)

# Generate (and cleanup) files containing variables static per build
infiles = $(filter-out debian/control.in debian/control.in.in, $(wildcard debian/*.in))
outfiles = $(subst $(libname)__VER__,$(libpkgname),$(basename $(infiles)))
pre-build:: $(outfiles)
$(outfiles): update-config debian/stamp-copyright-check
	sed $(SEDRULE_CONTENT) <$(subst $(libpkgname),$(libname)__VER__,$@).in >$@

clean::
	rm -f $(outfiles)

pre-build clean:: fail-source-not-repackaged

clean::
	[ ! -f Makefile ] || $(MAKE) soclean
	[ ! -f Makefile ] || $(MAKE) distclean
# These are somehow left...
	rm -rf sobin soobj gs.a

install/ghostscript::
	# Remove some of the scripts
	rm -f $(DEB_DESTDIR)/usr/bin/unix-lpr.sh $(DEB_DESTDIR)/usr/bin/lprsetup.sh $(DEB_DESTDIR)/usr/bin/pv.sh $(DEB_DESTDIR)/usr/bin/fixmswrd.pl

	# Do not include the Ghostscript loader executable with GTK support
	rm -f $(DEB_DESTDIR)/usr/bin/gsx

	# Rename /usr/bin/gsc, to not conflict with gambc
	mv $(DEB_DESTDIR)/usr/bin/gsc $(DEB_DESTDIR)/usr/bin/gs
	mkdir -p $(DEB_DESTDIR)/usr/sbin/
	install -m 755 debian/update-gsfontmap $(DEB_DESTDIR)/usr/sbin

	# Install Apport hook (Ubuntu only)
	if dpkg-vendor --is ubuntu; then \
		install -D -m 644 debian/ubuntu/apport-hook.py $(CURDIR)/debian/ghostscript/usr/share/apport/package-hooks/source_ghostscript.py; \
	fi

install/$(datapkgname)::
	# Strip CMap files (shipped separately, registered with DeFoMa)
	rm -rf $(DEB_DESTDIR)/usr/share/ghostscript/$(abi)/Resource/CMap

# Suggest fonts-droid (not ship DroidSansFallback.ttf)
CDBS_SUGGESTS_$(datapkgname) += , fonts-droid
#install/$(datapkgname)::
	#rm -f $(DEB_DESTDIR)/usr/share/ghostscript/$(abi)/Resource/CIDFSubst/DroidSansFallback.ttf

# Suggest texlive-lang-cjk
# (https://bugs.launchpad.net/ubuntu/+source/ghostscript/+bug/1449875)
CDBS_SUGGESTS_$(datapkgname) += , texlive-lang-cjk

install/libgs9::
	mkdir -p $(DEB_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
	mv $(DEB_DESTDIR)/usr/lib/*.so.* $(DEB_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)

install/libgs-dev::
	mkdir -p $(DEB_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
	install -m 644 gs.a \
		$(DEB_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libgs.a
	mv $(DEB_DESTDIR)/usr/lib/*.so $(DEB_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)

clean::
	rm -f debian/stamp-local-shlibs-$(libname)

binary-post-install/$(datapkgname)::
	file='debian/$(datapkgname)/usr/share/ghostscript/$(abi)/Resource/Init/cidfmap'; \
	  ! egrep -v '^(%([^%].*)?)?$$' "$$file" && rm "$$file" || ( \
		echo; \
		echo 'ERROR: cidfmap not virtually empty as expected,'; \
		echo '       so some alternative to just dropping that file is required.'; \
		echo '       More info at bug#531182.'; \
		exit 1 )

## ghostscript 9.19~dfsg

=== debian/changelog ===
ghostscript (9.19~dfsg-1) unstable; urgency=medium

  [ upstream ]
  * New release.
    Highlights:
    + New custom PJL (near) equivalents for pdfmark and
      setdistillerparams.
    + Metadata pdfmark implemented.
    + Add experimental, rudimentary raster trapping implementation.
    + Improved halftone threshold array generation tools.
    Other changes relevant for Debian:
    + copy_alpha now supports 8 bit depth (as well as 2 and 4).

  [ Jonas Smedegaard ]
  * Update watch file:
    + Bump file format to version 4.
    + Update upstream source URL.
    + Add repacksuffix hint.
    + Use uversionmangle (not dversionmangle) to adjust prereleases.
  * Drop CDBS get-orig-source target: Use "gbp import-orig --uscan"
    instead.
  * Update copyright info:
    + Update source URL.
    + Expand reasons for repackaging.
  * Add patch cherry-picked upstream to have configure support
    --without-pcl and --without-xps.
  * Configure --without-pcl (instead of moving aside pcl dir during
    build).

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 24 Mar 2016 18:19:43 +0100

ghostscript (9.19~~rc1~dfsg-1) experimental; urgency=medium

  [ upstream ]
  * New pre-release.

  [ Jonas Smedegaard ]
  * Update upstream tarball repackaging:
    + Stop strip ramfs code: Licensing issue resolved.
      Drop related patch 2009.
    + Stop strip ETS halftone code: Patent-encumbered yet believed to be
      DFSG-free.
    + Improve comments.
    + Strip non-DFSG fonts.
    + Strip convenience code copies cmpi Acrobat2Tiff.
    + Strip non-free PCL/PX3/XPS data files.
  * Switch to track GhostPDL (the larger project of which Ghostscript is
    a subset).
    Avoid building PCL writer for now: Fails with system-shared libjpeg.
  * Ignore tiger.xps and XLS files from copyright check.
  * Imported Upstream version 9.19rc1~dfsg
  * Update upstream-tarball hints for current upstream source.
  * Drop patches now applied upstream.
  * Unfuzz patches 2007 2010.
  * Update copyright info:
    + Update License-Grant of main Files section.
      Add comment on its non-default location.
    + Extend coverage for main upstream author.
  * Use CDBS to put aside cruft during build.
    Tighten to build-depend versioned on cdbs.
  * Update symbols file (9 missing).

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 14 Mar 2016 22:55:30 +0100

ghostscript (9.18~dfsg-4) unstable; urgency=medium

  * Really mark leaked png symbol as optional (not simply remove it, as
    it may then silently reappear as happened with 2.18~dfsg release).
    Closes: bug#809939. Thanks to Tobias Frost.
  * Add patch cherry-picked upstream to fix xpswrite/gprf builds with
    shared zlib (replacing patch 1002).
  * Add patch cherry-picked upstream to fix add gserrors.h to the
    installed files for the so-install target.
    Closes: Bug#814882. Thanks to Jean-Luc Coulon.
  * Recommend fonts-droid-fallback (not fonts-droid now dropped).
    Closes: Bug#804684. Thanks to Daniel Serpell.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 16 Feb 2016 20:59:55 +0100

ghostscript (9.18~dfsg-3) unstable; urgency=medium

  * Fix use space (not comma) as arch delimiter in symbols file.
    Thanks to John Paul Adrian Glaubitz

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 15 Feb 2016 16:53:25 +0100

ghostscript (9.18~dfsg-2) unstable; urgency=medium

  * Update symbols file:
    + Drop hdr_id for sparc and sparc64 since 2.16~dfsg.
      Closes: Bug#814702. Thanks to John Paul Adrian Glaubitz.
    + Update list of confirmed archs.
  * Release for unstable, despite symbols changes: None of the dropped
    symbols are mentioned in any Debian code except ghostscript itself
    (according to codesearch.debian.net).

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 15 Feb 2016 15:46:02 +0100

ghostscript (9.18~dfsg-1) experimental; urgency=medium

  [ upstream ]
  * New release 9.18,
    Highlights:
    + Integrate GhostPDL build routines into Ghsotscript.
    + New technique of "device subclassing".  Consistent -dFirstPage and
      -dLastPage filters implemented using that technique.
    + Digitally signed binaries for Windows.
    Other changes relevant for Debian:
    + Reintroduces tiffscaled* devices.
      Closes: bug#786967. Thanks to Marc Lehmann.

  [ Jonas Smedegaard ]
  * Update watch file to mangle release candidates.
  * Update copyright info:
    + Extend coverage of Debian packaging.
    + Add Files section for a few Apache-licensed files.
    + Adjust for a few renamed files.
    + Clarify reasons for source tarball repackaging.
  * Drop uptream cherry-picked patch since applied.
  * Unfuzz all patches.
  * Add patches cherry-picked upstream to fix handle IJS and X11 as
    subclassed devices.
    Thanks to Till Kamppeter.
  * Update patch 2009.
  * Extend patch 1002 to fix shared zlib linkage for gprf (not only
    xps).
  * Add patches cherry-picked upstream to fix makefiles and to implement
    -dTIFFDateTime=false option.
    Thanks to Damian Dimmich.
  * Declare compliance with Debian Policy 3.9.7.
  * Mark libgs9-common as multi-arch foreign.
    Closes:Bug#794527. Thanks to Helmuth Grohne.
  * Acknowledge release 9.16~dfsg-2.1.
    Thanks to Tobias Frost.
  * Add patch 1003 to fix document ps2pdf -dCompatibilityLevel option.
    Closes: bug#799836. Thanks to Trent W. Buck.
  * Update package relations:
    + Build-depend on libopenjp2-7-dev (not libopenjpeg-dev).
    + Relax to recommend (not depend on) gsfonts.
      Closes: bug#812088. Thanks to IOhannes m zmölnig.
  * Modernize Vcs-* fields: Use https protocol and cgit.
  * Track symbols in one single file.
  * Update symbols file for amd64 architecture.
  * Add patch 1001 to fix openjpeg linkage.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 13 Feb 2016 10:17:32 +0100

ghostscript (9.16~dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove leaked png_push_fill_buffer symbol from symbol files
    to build with libpng1.6 (Closes: #809939)



=== debian/control ===
Source: ghostscript
Section: text
Priority: optional
Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
Build-Depends: cdbs (>= 0.4.106~),
 autoconf,
 debhelper,
 dh-buildinfo,
 devscripts,
 libregexp-assemble-perl,
 libimage-exiftool-perl,
 libfont-ttf-perl,
 liblcms2-dev (>= 2.5),
 d-shlibs (>= 0.58~),
 libjpeg-dev,
 libpng-dev,
 libtrio-dev,
 libtiff-dev,
 libz-dev,
 libjbig2dec-dev,
 libijs-dev,
 libexpat-dev,
 libxt-dev,
 libxext-dev,
 libx11-dev,
 libice-dev,
 libsm-dev,
 libopenjp2-7-dev,
 libfreetype6-dev,
 libfontconfig1-dev,
 libcups2-dev,
 libcupsimage2-dev,
 libpaper-dev,
 libidn11-dev,
 freeglut3-dev,
 pkg-config
Standards-Version: 3.9.7
Uploaders: Jonas Smedegaard <dr@jones.dk>,
 Michael Gilbert <mgilbert@debian.org>,
 Bastien ROUCARIÈS <roucaries.bastien+debian@gmail.com>
Homepage: http://www.ghostscript.com/
Vcs-Git: https://anonscm.debian.org/git/printing/ghostscript.git
Vcs-Browser: https://anonscm.debian.org/cgit/printing/ghostscript.git

Package: ghostscript
Architecture: any
Multi-Arch: foreign
Provides: ${cdbs:Provides}
Recommends: ${cdbs:Recommends}
Suggests: ${cdbs:Suggests}
Depends: ${shlibs:Depends},
 ${cdbs:Depends},
 libgs9 (= ${binary:Version}),
 ${misc:Depends}
Description: interpreter for the PostScript language and for PDF
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 Furthermore, it can render PostScript and PDF files as graphics to be
 printed on non-PostScript printers. Supported printers include common
 dot-matrix, inkjet and laser models.

Package: ghostscript-x
Architecture: any
Depends: ${shlibs:Depends},
 ${cdbs:Depends},
 ${misc:Depends}
Description: interpreter for the PostScript language and for PDF - X11 support
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package contains the GPL Ghostscript output device for X11.

Package: ghostscript-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends},
 ${cdbs:Depends},
 ${misc:Depends}
Suggests: ${cdbs:Suggests}
Description: interpreter for the PostScript language and for PDF - Documentation
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package contains documentation for GPL Ghostscript, mainly
 targeted developers and advanced users.

Package: libgs9
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
 ${cdbs:Depends},
 ${misc:Depends},
 libgs9-common (= ${source:Version})
Description: interpreter for the PostScript language and for PDF - Library
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package provides the Ghostscript library which makes the
 facilities of GPL Ghostscript available to applications.

Package: libgs9-common
Section: libs
Architecture: all
Depends: ${misc:Depends}
Recommends: ${cdbs:Recommends}
Multi-Arch: foreign
Description: interpreter for the PostScript language and for PDF - common files
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package provides common architecture-independent files needed by
 the GPL Ghostscript library.
 .
 By default, GPL Ghostscript uses a font from the fonts-droid package to
 approximate glyphs in PDFs for which the requested CJK TrueType font
 is missing.  If the fonts-droid package is not installed, these glyphs
 will be rendered as bullets.

Package: libgs-dev
Section: libdevel
Architecture: any
Depends: ${devlibs:Depends},
 ${cdbs:Depends},
 ${misc:Depends}
Description: interpreter for the PostScript language and for PDF - Development Files
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package provides the development files for the GPL Ghostscript
 library which makes the facilities of GPL Ghostscript available to
 applications.

Package: ghostscript-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${shlibs:Depends},
 ${cdbs:Depends},
 libgs9 (= ${binary:Version}) |
 ghostscript (= ${binary:Version}) |
 ghostscript-x (= ${binary:Version}),
 ${misc:Depends}
Description: interpreter for the PostScript language and for PDF - Debug symbols
 GPL Ghostscript is used for PostScript/PDF preview and printing.
 Usually as a back-end to a program such as ghostview, it can display
 PostScript and PDF documents in an X11 environment.
 .
 This package contains the debugging symbols for ghostscript,
 ghostscript-x, and libgs9.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2004-2009, Masayuki Hatta (mhatta) <mhatta@debian.org>
# Copyright © 2009-2016, Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for GhostPDL
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# These are needed ahead of including CDBS
# ABI by default follows upstream version (without repackaging suffix)
abi = $(firstword $(subst ~,$(space),$(DEB_UPSTREAM_VERSION)))
major = $(firstword $(subst .,$(space),$(DEB_UPSTREAM_VERSION)))
SEDRULE_CONTENT = 's/__ABI__/$(abi)/g;s/__VER__/$(major)/g'
DEB_PHONY_RULES += debian/control.in
debian/control:: debian/control.in
debian/control.in::
	sed $(SEDRULE_CONTENT) <debian/control.in.in >debian/control.in
DEB_AUTO_UPDATE_AUTOCONF = 2.67

include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk

libname = libgs
pkg = ghostscript
pkg-x11 = ghostscript-x
pkg-doc = ghostscript-doc
pkg-lib = $(libname)$(major)
pkg-dev = $(libname)-dev
pkg-data = $(libname)$(major)-common

# Build-depend unversioned on debhelper
#  TODO: Drop when adopted in cdbs
CDBS_BUILD_DEPENDS_rules_debhelper_v9 = debhelper

# extract metadata from ICC, PDF, and fonts before copyright check
# - and skip main HTML documentation
CDBS_BUILD_DEPENDS +=, libregexp-assemble-perl, libimage-exiftool-perl
CDBS_BUILD_DEPENDS +=, libfont-ttf-perl
local_inspection_regex = icc|pdf|ttf
local_inspection_exif_dir = Resource/Font/
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^((.*/)?[^/]+\.($(local_inspection_regex))|$(local_inspection_exif_dir).*|doc/.*\.htm|xps/tools/tiger\.xps|.*\.xls|debian/(changelog|copyright(|_hints|_newhints)))$$
debian/stamp-copyright-check: debian/stamp-extract-copyright
debian/stamp-extract-copyright:
	find * -type f -regextype posix-extended \
		-regex '.*\.($(local_inspection_regex))' \
		-print0 | perl -0 debian/license-miner
	find $(local_inspection_exif_dir) -type f \
		-printf 'exif:%p\0' | perl -0 debian/license-miner
	touch $@
pre-build:: clean-extracted-copyright-during-build
clean-extracted-copyright-during-build: debian/stamp-copyright-check
	find -type f -name '*.metadata_dump' -delete
clean::
	find -type f -name '*.metadata_dump' -delete
	rm -f debian/stamp-extract-copyright

# put aside upstream-shipped temp files during build but after copyright-check
DEB_UPSTREAM_CRUFT_MOVE = configure

# TODO: enable when supporting system-shared libjpeg
# http://bugs.ghostscript.com/show_bug.cgi?id=696654
DEB_CONFIGURE_EXTRA_FLAGS += --without-pcl

# workaround for autotools-resolved paths ignored in base/unix-auth.mak
export DEB_HOST_MULTIARCH

# Support parallel building if enabled in DEB_BUILD_OPTIONS
DEB_BUILD_PARALLEL = 1

gs_opts += SHARE_JPEG=1
dev-deps += jpeg

gs_opts += SHARE_LIBPNG=1
dev-deps += png

gs_opts += SHARE_TRIO=1
dev-deps += trio

gs_opts += SHARE_LIBTIFF=1
DEB_CONFIGURE_EXTRA_FLAGS += --with-system-libtiff
dev-deps += tiff

gs_opts += SHARE_ZLIB=1
dev-deps += z

gs_opts += SHARE_JBIG2=1
DEB_CONFIGURE_EXTRA_FLAGS += --with-jbig2dec
dev-deps += jbig2dec

gs_opts += SHARE_IJS=1
DEB_CONFIGURE_EXTRA_FLAGS += --with-ijs
dev-deps += ijs

gs_opts += SHARE_EXPAT=1
dev-deps += expat

DEB_CONFIGURE_EXTRA_FLAGS += --with-x --disable-gtk
dev-deps += xt xext x11 ice sm

DEB_CONFIGURE_EXTRA_FLAGS += --enable-dynamic
DEB_CONFIGURE_EXTRA_FLAGS += --disable-compile-inits

# TODO: enable when working again (failed since 9.07 and maybe 9.06)
#DEB_CONFIGURE_EXTRA_FLAGS += --with-omni
DEB_CONFIGURE_EXTRA_FLAGS += --with-drivers=ALL

# need recent lcms supporting threads (via cmsPluginTHR() call)
gs_opts += WHICH_CMS=lcms2 SHARE_LCMS=1 LCMS2DIR=/usr
CDBS_BUILD_DEPENDS +=, liblcms2-dev (>= 2.5)

# openjpeg requires patching for ICC and CMYK support
gs_opts += SHARE_JPX=1
#DEB_CONFIGURE_EXTRA_FLAGS += --disable-openjpeg
dev-deps += openjp2-7

fontdirs = /var/lib/ghostscript/fonts /usr/share/cups/fonts \
 /usr/share/ghostscript/fonts /usr/local/lib/ghostscript/fonts \
 /usr/share/fonts
gs_opts += SHARE_FT=1
DEB_CONFIGURE_EXTRA_FLAGS += --enable-freetype \
 --with-fontpath=$(subst $(space),:,$(strip $(fontdirs)))
dev-deps += freetype6 fontconfig1

# avoid building CUPS driver when bootstrapping an architecture
ifeq (,$(findstring stage1,$(DEB_BUILD_PROFILES)))
gs_opts += SHARE_LCUPS=1 SHARE_LCUPSI=1
DEB_CONFIGURE_EXTRA_FLAGS += --enable-cups
endif
dev-deps += cups2 cupsimage2

DEB_MAKE_BUILD_TARGET = so gs.a $(gs_opts)
DEB_MAKE_INSTALL_TARGET = soinstall DESTDIR=$(DEB_DESTDIR) $(gs_opts)

DEB_DH_MAKESHLIBS_ARGS_$(pkg-x11) = -n

# avoid checking symbols file when bootstrapping an architecture
ifneq (,$(findstring stage1,$(DEB_BUILD_PROFILES)))
DEB_DH_MAKESHLIBS_ARGS = -- -c0
endif

pre-build:: debian/control.in.in
	echo "sed $(SEDRULE_CONTENT) <$< | diff -u debian/control.in -"
	@sed $(SEDRULE_CONTENT) <$< | diff -u debian/control.in - || ( \
		echo; \
		echo "Upstream version has changed (or debian/control.in.in is out of sync)"; \
		echo "Edit debian/control manually, or use the following command:"; \
		echo "  DEB_AUTO_UPDATE_DEBIAN_CONTROL=yes fakeroot debian/rules clean"; \
		exit 1)

# Generate (and cleanup) files containing variables static per build
infiles = $(filter-out debian/control.in debian/control.in.in, $(wildcard debian/*.in))
outfiles = $(subst $(libname)__VER__,$(pkg-lib),$(basename $(infiles)))
pre-build:: $(outfiles)
$(outfiles): update-config debian/stamp-copyright-check
	sed $(SEDRULE_CONTENT) <$(subst $(pkg-lib),$(libname)__VER__,$@).in >$@
clean::
	rm -f $(outfiles)

clean::
	[ ! -f Makefile ] || $(MAKE) soclean
	[ ! -f Makefile ] || $(MAKE) distclean
# These are somehow left...
	rm -rf sobin soobj gs.a

# Remove some of the scripts
bin-avoid = unix-lpr.sh lprsetup.sh pv.sh fixmswrd.pl
install/$(pkg)::
	rm -f $(patsubst %,$(DEB_DESTDIR)/usr/bin/%,$(bin-avoid))

# Do not include the Ghostscript loader executable with GTK support
install/$(pkg)::
	rm -f $(DEB_DESTDIR)/usr/bin/gsx

# Rename /usr/bin/gsc, to not conflict with gambc
install/$(pkg)::
	mv $(DEB_DESTDIR)/usr/bin/gsc $(DEB_DESTDIR)/usr/bin/gs
	mkdir -p $(DEB_DESTDIR)/usr/sbin/
	install -m 755 debian/update-gsfontmap $(DEB_DESTDIR)/usr/sbin

# Move ICC profiles to shared dir, to allow reuse by others.
install/$(pkg-data)::
	mkdir -p $(DEB_DESTDIR)/usr/share/color/icc
	mv $(DEB_DESTDIR)/usr/share/ghostscript/$(abi)/iccprofiles \
		$(DEB_DESTDIR)/usr/share/color/icc/ghostscript

# Strip CMap files (separately packaged in poppler-data)
install/$(pkg-data)::
	rm -rf $(DEB_DESTDIR)/usr/share/ghostscript/$(abi)/Resource/CMap

# Recommend fonts-droid (not ship DroidSansFallback.ttf)
CDBS_RECOMMENDS_$(pkg-data) +=, fonts-droid-fallback
install/$(pkg-data)::
	rm -f $(DEB_DESTDIR)/usr/share/ghostscript/$(abi)/Resource/CIDFSubst/DroidSansFallback.ttf

install/$(pkg-dev)::
	mkdir -p $(DEB_DESTDIR)/usr/lib/
	install -m 644 gs.a \
		$(DEB_DESTDIR)/usr/lib/libgs.a

# Let d-shlibs calculate development package dependencies
#  and handle shared library install
# * recent d-shlibs needed to handle libtrio quirk
CDBS_BUILD_DEPENDS +=, d-shlibs (>= 0.58~)
binary-post-install/$(pkg-lib):: debian/stamp-local-shlibs-$(libname)
debian/stamp-local-shlibs-$(libname): binary-install/$(pkg-lib)
	d-shlibmove --commit \
		--devunversioned --ignorelibdep \
		--movedev "debian/tmp/usr/include/*" usr/include/ \
		debian/tmp/usr/lib/$(libname).so
clean::

=== debian/watch ===
# Run the "uscan" command to check for upstream updates and more.
version=4
opts="dversionmangle=s/~dfsg\d*$//,repacksuffix=~dfsg,uversionmangle=s/(?:\d)(rc)/~~$1/" \
 http://www.ghostscript.com/download/gpdldnld.html \
 (?:.*?/)?ghostpdl-(\d.*)\.tar\.gz debian uupdate
